;        PC-9801-92 BIOS ROM code ̗eʕǖc[ 2.00  2023-2-24

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
DATA_BLOCK_SIZE equ     8000h
                org 100h  ; MS-DOS COM`vO
start:          jmp     main    ; ɃWv
;------------ ROM CODE INSTRUCTIONS ----------------
.386
;----------------------------- static data -----------------------------
align 4
WorkMemAddr     label   dword
DataBufferOfs   DW      0000h   ; Allocated by DOS int 21h,ah=48h
DataBufferSeg   DW      8000h   ; DOS allocated segment (ES)
DOS_handle1     DW      -1
DOS_handle2     DW      -1
DataBlock       DW      0
BeepTimes       DW      8740h   ; "@"
ProgramTitle    DB    1Bh,"[47m"
 DB " PC-9801-92 BIOS ROM̉(vi486@) 1.00  Copyright(C) 2023 ܂(DOSsoft) ",13,10,1Bh,"[m",0
msg_not98       DB      "This machine is not PC-9800 series"
CRLF            DB      13,10,0
PatchJob        DB      " 8192օۅ̅􅭅{. ",0
code_replacing  DB      "                         JMP C+2 out 5Fh,al Œuł(0`3FFF).",0
err_abort       DB      "yG[zvOُ͈I܂.",13,10,0
                DB      "Program abnormally terminated.",13,10,0
EndJob          DB      "I܂.",13,10,0
;----------------------------- data end ---------------------------------
.386            
DOS_PPROGRAM_AREA       label byte 
main:           mov     cx,4
                mov     bx,offset stackbase+1024        ; X^bN1024oCg
                shr     bx,cl
                add     bx,17
                mov     ah,4Ah  ; gpJ
                int 21h
                mov     ax,bx
                shl     ax,cl
                dec     ax
                mov     sp,ax           ; X^bN͂ύX

                mov     dx,offset ProgramTitle
                call    _puts
                call    machine_check   ; XWǂ̃`FbN
                mov     al,0FFh         ; G[ԒlFF
                jc      ErrExitDOS      ; L[Β~
                call    AllocateDiskBuf ; DMAẼt64KB
                call    GetFilenames

                mov     es,DataBufferSeg

                mov     DataBlock,0     ; f[^ubÑJE^ϐ

                call    OpenFile        ; ǂݍ݃t@CI[v
                jc      ErrExitDOS
                call    CreateFile      ; ݃t@CI[v
                jc      ErrExitDOS
LoopDataBlock:  mov     BeepTimes,8740h   ; "@"\̂
                mov     es,DataBufferSeg
                call    LoadFile32K
                jc      ErrExitDOS

                mov     dx,offset PatchJob
                call    _puts

                call    Patch8192Cyln

                mov     dx,offset CRLF
                call    _puts

                cmp     DataBlock,2
                jae     @f
                call    Umekomi
        @@:     
                cmp     DataBlock,2
                jb      @f
                mov     es,DataBufferSeg
                mov     dx,offset code_replacing
                call    _puts
                call    Jmp2_Out5f
                mov     dx,offset CRLF
                call    _puts
        @@:     
                call    SaveFile32K
                jc      ErrExitDOS
                inc     DataBlock
                cmp     DataBlock,4
                jb      LoopDataBlock

                call    CloseFiles

                mov     dx,offset EndJob
                call    _puts
                mov     al,00h
                jmp     ExitDOS
ErrExitDOS:     mov     dx,offset err_abort
                call    _puts
                mov     al,0FFh
ExitDOS:        mov     ah,4Ch
                int 21h
                RET

;--------------------------------------------------------------------------
;       Patch8192Cyln   
;--------------------------------------------------------------------------
Patch8192Cyln   PROC   near
                mov     es,DataBufferSeg

; patch0A       ; 8GBΉł͖gp
                mov     si,offset E10code0
                mov     cx,( offset E10code0_end - offset E10code0 )
                mov     di,0030h
                mov     dx,0FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx
                mov     si,offset E10patch0
           rep  movsb
                call    ShortBeep
           @@:
; patch0B       ; 8GBΉł͖gp
                mov     si,offset E10code0
                mov     cx,( offset E10code0_end - offset E10code0 )
                mov     di,1030h
                mov     dx,1FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx
                mov     si,offset E10patch0
           rep  movsb
                call    ShortBeep
           @@:
; patch1A
                mov     si,offset E10code1
                mov     cx,offset ( E10code1_end - offset E10code1 )
                mov     di,0030h
                mov     dx,0FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch1
           rep  movsb
                call    ShortBeep
           @@:
; patch1B
                mov     si,offset E10code1
                mov     cx,offset ( E10code1_end - offset E10code1 )
                mov     di,1030h
                mov     dx,1FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch1
           rep  movsb
                call    ShortBeep
           @@:
; patch2A
                mov     si,offset E10code2
                mov     cx,( offset E10code2_end - offset E10code2)
                mov     di,0030h
                mov     dx,0FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch2
         rep    movsb
                call    ShortBeep
            @@:
; patch2B
                mov     si,offset E10code2
                mov     cx,( offset E10code2_end - offset E10code2)
                mov     di,1030h
                mov     dx,1FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch2
         rep    movsb
                call    ShortBeep
            @@: 
; patch3A
                mov     si,offset E10code3
                mov     cx,( offset E10code3_end - offset E10code3)
                mov     di,0030h
                mov     dx,0FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch3
         rep    movsb
                call    ShortBeep
            @@:
; patch3B
                mov     si,offset E10code3
                mov     cx,( offset E10code3_end - offset E10code3)
                mov     di,1030h
                mov     dx,1FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch3
         rep    movsb
                call    ShortBeep
           @@:
; patch4A
                mov     si,offset E10code4
                mov     cx,( offset E10code4_end - offset E10code4)
                mov     di,0030h
                mov     dx,0FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch4
         rep    movsb
                call    ShortBeep
            @@:
; patch4B
                mov     si,offset E10code4
                mov     cx,( offset E10code4_end - offset E10code4)
                mov     di,1030h
                mov     dx,1FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch4
         rep    movsb
                call    ShortBeep
            @@:

; patch5A
                mov     si,offset E10code5
                mov     cx,( offset E10code5_end - offset E10code5)
                mov     di,2000h
                mov     dx,2FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch5
         rep    movsb
                call    ShortBeep
            @@:

; patch5B
                mov     si,offset E10code5
                mov     cx,( offset E10code5_end - offset E10code5)
                mov     di,3000h
                mov     dx,3FFFh
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset E10patch5
         rep    movsb
                call    ShortBeep
            @@:
                clc
                ret
No_match:       
                stc
                ret
Patch8192Cyln   ENDP

;--------------------------------------------------------------------------
;       łł邱ƂVOi`̖ߍ
;--------------------------------------------------------------------------
Umekomi         PROC   near
                mov     di,0FF0h
                mov     si,offset Message0
                mov     cx,offset Message1 - offset Message0
        rep     movsb
                mov     di,1FF0h
                mov     si,offset Message1
                mov     cx,offset Message1 - offset Message0
        rep     movsb
                ret
Message0        DB      "8192OK",0
Message1        DB      "8192OK",0
Umekomi         ENDP

;--------------------------------------------------------------------------
;       Jmp2_Out5f
;--------------------------------------------------------------------------
Jmp2_Out5f      PROC   near
                mov     di,DataBufferOfs
                mov     es,DataBufferSeg
                mov     cx,DATA_BLOCK_SIZE/2
                sub     cx,10h
Jmp_Out5f_ent:
                mov     ax,es:[di]
                cmp     ax, 00EBh
                jnz     @f
;;;;            call    PrintAddrDI
                mov     ax,5FE6h
                mov     es:[di],ax
           @@:  nop
                inc     di
               loop     Jmp_Out5f_ent

                ret
Jmp2_Out5f      ENDP

;-----------------------------------------------------------------
;       fBXNI/Ô߂̃obt@m
;-----------------------------------------------------------------
        PUBLIC  AllocateDiskBuf 
AllocateDiskBuf PROC    near
                mov     bx,4000h        ; paragraph size, 128KBm
                inc     bx
                mov     ax,4800h        ; ZOg𓾂
                int     21h
                jc      mem_a_error
                and     ax,0F000h       ; 
                add     ax, 1000h       ; 64KBEɂ
                mov     DataBufferSeg,ax
                mov     dx,ax           ; ZOgFOԂ
                xor     ax,ax
                mov     DataBufferOfs,ax
                mov     di,ax
                mov     cx,8000h        ; 64KB(32KW) [ŏ
                mov     es,dx
            rep stosw
                mov     dx,offset msg_mAllocOK
                call    _puts
                clc
                ret
mem_a_error:    mov     dx,offset err_mAllocFail
                call    _puts
                stc
                ret
AllocateDiskBuf ENDP


;--------------------------------------------------------------------------
;       m
;--------------------------------------------------------------------------

MemAlloc128K    PROC   near
                mov     bx,2000h  ; paragraph size*16= byte size 128KB
                inc     bx
                mov     ax,4800h
                int     21h
                jc      mem_err
                mov     DataBufferSeg,ax
;                push    es
                mov     es,ax
                mov     di,0
                mov     cx,32768 ; 
                xor     ax,ax
            rep stosw
;                pop     es
                mov     dx,offset msg_mAllocOK
                call    _puts
                clc
                ret
mem_err:        mov     dx,offset err_mAllocFail
                call    _puts
                stc
                ret
err_mAllocFail  DB "̋󂫂sĂ̂ősł܂.",13,10,0
;msg_mAllocOK    DB "64KB Ѕх֊m.",13,10,0
msg_mAllocOK    DB "64KB m.",13,10,0
msg_mAllocFail  DB 13,10,0
MemAlloc128K    ENDP

;-------------------------------------------------------


;---------------------------------------------------------------
;       SaveFile32K
;---------------------------------------------------------------
SaveFile32K     PROC    near
                mov     bx,DOS_handle2
                mov     cx,DATA_BLOCK_SIZE
                mov     dx,DataBufferOfs
                mov     ax,DataBufferSeg
                 push    ds
                 mov     ds,ax
                 mov     ax,4000h     ; write to file
                 int 21h
                 pop     ds
                jc      write_err
                cmp     ax,DATA_BLOCK_SIZE
                jnz     write_err
                mov     dx,offset WriteMsg
                call    _puts
                clc
                ret
write_err:      mov     dx,offset WriteErrMsg
                call    _puts
                stc
                ret
WriteErrMsg     DB "t@C݂Ŏs܂. ",13,10,0
WriteMsg        DB "t@C݂܂. ",13,10,0
SaveFile32K        ENDP

;-----------------------------------------------------------------
;       LoadFile32K        DS:DX   = file buffer
;-----------------------------------------------------------------
LoadFile32K        PROC    near
                mov     ax,DataBufferSeg
                mov     dx,DataBufferOfs
                mov     cx,DATA_BLOCK_SIZE
                mov     bx,DOS_handle1   ; int21, func 3F
                push    ds
                 mov     ds,ax
                 mov     ax,3F00h        ; DOS function call (read)
                 int 21h
                pop     ds
                jc      read_err2
                cmp     ax,DATA_BLOCK_SIZE
                jne     read_err2
                mov     dx,offset ReadMsg
                call    _puts
                clc
                ret
read_err2:      
                mov     dx,offset ReadErrMsg
                call    _puts
                stc
                ret
ReadErrMsg      DB "t@CǍ݂Ŏs܂. ",13,10,0
ReadMsg         DB "t@CǍ݂܂. ",0

LoadFile32K        ENDP


;--------------------------------------------------------------------------
;       CloseFiles      
;--------------------------------------------------------------------------
CloseFiles      PROC   near
                mov     bx,DOS_handle1
                mov     ah,3Eh  ; close 
                xor     dx,dx
                int     21h
                mov     bx,DOS_handle2
                mov     ah,3Eh
                xor     dx,dx
                int     21h
                ret
CloseFiles      ENDP

;-----------------------------------------------------------------
;       OpenFile
;-----------------------------------------------------------------
OpenFile        PROC   near
                mov     dx,offset InputFileName
                call    _puts
                
                mov     ax,3D00h
                xor     bx,bx
                int 21h
                jc      open_err1
                mov     DOS_handle1,ax
                mov     dx,offset OpenedMsg
                call    _puts
                clc
                ret     
open_err1:      mov     dx,offset OpenErrMsg
                call    _puts
                mov     DOS_handle1,-1
                stc
                ret     
OpenErrMsg      DB " : t@C̃I[vŎs܂. ",13,10,0
OpenedMsg       DB " : t@CI[v܂. ",13,10,0
OpenFile        ENDP

;---------------------------------------------------------------
;       CreateFile      
;---------------------------------------------------------------
CreateFile      PROC   near
                mov     dx,offset OutputFileName
                call    _puts
                mov     dx, offset OutputFileName
                mov     cx, 0020h       ; VK쐬
                mov     ax,3C00h        ; ݂ŃI[v
                xor     bx,bx
                int     21h
                jc      creat_err
                mov     DOS_handle2,ax
                mov     dx,offset CreatedMsg
                call    _puts
                clc
                ret
creat_err:      mov     dx,offset CreatErrMsg
                call    _puts
                mov     DOS_handle2,-1
                stc
                ret
CreatErrMsg     DB " : t@C̍쐬Ŏs܂. ",13,10,0
CreatedMsg      DB " : t@C쐬܂. ",13,10,0
CreateFile      ENDP

;--------------------------------------------------------------------------
;       machine_check   
;--------------------------------------------------------------------------
machine_check   PROC   near     
                mov     ah,00
                mov     cx,0FFFFh       ; 悭mꂽ98/AT`FbN
                int 1Ah
                cmp     cx,0FFFFh
                jNE     NotPC98  
;                mov     dx,offset msg_copyright ; o[W\LA
;                call    _puts
                clc
                ret
NotPC98:        
                mov     dx,offset msg_not98
                call    _puts  ; int 21ŕ\
                stc
                ret
machine_check   ENDP

;------------------------------------------------------------------------
;   PrintAddrDI   DI̐l\Zi4ElA擪Xy[X܂5ŕ\
;------------------------------------------------------------------------
PrintAddrDI     PROC   near
                pushad
                mov     bx,offset DecimalString+4
                mov     dx,di
                mov     cx,4
Ent4:           mov     ah,dl
                and     ah,0Fh
                cmp     ah,09
                ja      Hexa
                mov     al,30h
                add     al,ah
                jmp     both9X
        Hexa:
                mov     al,37h
                add     al,ah
both9X:         mov     ds:[bx],al
                dec     bx
                shr     dx,4
               loop     Ent4

                mov     dx,offset DecimalString
                call    _puts
                popad
                ret
DecimalString   DB      20h,20h,20h,20h,20h,0
PrintAddrDI     ENDP


;-----------------------------------------------------------------
;       _puts in MS-DOS
;-----------------------------------------------------------------
_puts           PROC    near
                pusha
                mov     bx,dx
_puts_ent:      cmp     byte ptr [bx],0
                jz      @f
                inc     bx
                jmp     _puts_ent
        @@:     mov     byte ptr [bx],'$'
                mov     ah,9
                int 21h
                mov     byte ptr [bx],0
                popa
                ret
_puts           ENDP

_putw           PROC    near
                pusha
                mov     cx,ax
                mov     dl,ch
                mov     ah,2
                int 21h
                mov     dl,cl
                mov     ah,2
                int 21h
                popa
                ret
_putw           ENDP


;--------------------------------------------------------------------------
;  SCSI BIOS 1GBӏR[h ^ 8GBǃR[h
;--------------------------------------------------------------------------
E10code0        label   byte
                and     dx,00FFh      ; mask 24bit
                div     bx
E10code0_end    label   byte

E10patch0       label   byte
                and     dx,0FFFh      ; mask 28bit ; 81E2FF0F
                div     bx            ;
E10patch0_end   label   byte

E10code1        label   byte
                test    byte ptr [bp+50h],80h  ; DA/UA
                DB      75h
                DB      08h     ; jnz   E10code1_end
                mov     dl,[bp+56h]     ; DL
                mov     ax,[bp+54h]     ;
                DB     0EBh             ; JMP
                DB      24h             ; 
E10code1_end    label   byte

E10patch1       label   byte
                mov     eax,[bp+54h]    ; eax <==[bp+54],[bp+56]
                bswap   eax
                nop
                test    byte ptr [bp+50h],80h  ; DA/UA
                DB      74h             ; JZɕύX
                DB      24h+5           ; WvToCgɂ炷
E10patch1_end   label   byte

E10code2        label byte
                mov     al,[bx+01h]    ; head count
                and     al,0Fh         ; 4bit}XN
                xor     ah,ah          ;  wbh<15@
                mov     cx,[bp+54h]    ;
                mul     cx
                add     al,[bp+57h]
                adc     ah,00h
                mov     cl,[bx]
                xor     ch,ch
                mul     cx
                add     al,[bp+56h]
                adc     ah,00h
                adc     dx,+00h
                mov     [bp+07h],dl
                mov     [bp+08h],ah
                mov     [bp+09h],al
E10code2_end    label byte

E10patch2       label byte              ; DS= 0;  BX=0460h+ID*4
                mov     al,[bx+01h]             ; AL= BIOSwbh
                and     al,0Fh                  ; 4bit}XN
                movzx   ecx,al                  ; wbhECX
                movzx   eax,word ptr [bp+54h]   ; [bp+54h]V_ԍ
                mul     ecx                     ; Z
                mov     cl,[bp+57h]             ; [bp+57h]wbhԍ
                add     eax,ecx                 ; Z
                mov     cl,byte ptr [bx]        ; CL= BIOSZN^
                mul     ecx                     ; Z
                mov     cl,byte ptr [bp+56h]    ; [bp+56h]ZN^ԍ
                add     eax,ecx                 ; Z EAX jAAhX
                bswap   eax
                nop
                mov      [bp+06h],eax            ;
E10patch2_end   label byte

E10code3        label byte
                mov     dl,[bp+14h]
                mov     ax,[bp+15h]
                test    byte ptr [bp+10h],80h
E10code3_end   label byte

E10patch3       label byte
                mov     dx,[bp+14h]
                mov     ax,[bp+15h]
                test    byte ptr [bp+10h],80h
E10patch3_end   label byte

E10code4        label byte
                mov     [bp+56h],dl
                xchg    ah,al
E10code4_end    label byte

E10patch4       label byte
                mov     [bp+56h],dx
                xchg    ah,al
E10patch4_end   label byte

E10code5       label   byte
                DB      0F6h,76h,39h    ;div     byte ptr [bp+39]
                DB      25h,0FFh,00h    ;and     ax,00FF
E10code5_end    label   byte

E10patch5       label   byte
                DB      0F6h,76h,39h    ;div     byte ptr [bp+39]
                DB      25h,0FFh,0Fh    ;and     ax,0FFF
E10patch5_end   label   byte




if 0
SetVector00     label byte      ; DS=0  org 0FE4h
                mov     word ptr ds:[0],0FD8h
                mov     word ptr ds:[2],cs
                DB      0E9h
SetVector00_JMP DW      0FF6Dh
SetVector00_E   label byte

div0recover     label byte      ; org 0FD8h
                pop     ax      ; retrive previous stack
                inc     ax      ; 2 byte before the called addresss 
                inc     ax
                push    ax      ; store the adress to stack memory
                mov     dx,0            ; return value of DX:AX is set to
                mov     ax,0FFFEh       ; maximum of 16bit -1 
                iret            ; resume instruction
div0recover_E   label byte
endif
;--------------------------------------------------------------------
;       scan_string  386   ̔r[`  
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j SẴWX^ >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_string     PROC    near
                xor     bx,bx
                add     dx,di
scan_ent:       mov     eax,ds:[si]
                cmp     eax,es:[di]
                jnz     scan_No_match

                mov     bx,di
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  
                cmp     di,dx
                jae     @f
                inc     di
                jmp     scan_ent
        @@:     
                stc                     ; scan NG
                ret
scan_string     ENDP

ShortBeep       PROC   near
                push    ax
                push    cx
                push    dx

                mov     ax,BeepTimes
;                xchg    al,ah
                call    _putw
                inc     word ptr BeepTimes
                
                mov     al,06h
                out     37h,al
                mov     cx,333h
wait1:          out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     wait1
                mov     al,07h
                out     37h,al
                mov     cx,02444h
wait2:          out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     wait2
                
                pop     dx
                pop     cx
                pop     ax
                ret
ShortBeep       ENDP

;------------------------------------------------
GetFilenames    PROC   near
                push    ds
                pop     es
                cld
                mov     dx,offset Prompt
                call   _puts
                mov     dx,offset PromptI
                call   _puts
                mov     dx, offset InputBuffer
                mov     ah,0Ah
                int 21h
                mov     dx,offset CRLF
                call    _puts
                mov     al,0
                mov     ch,0
                mov     cl,StringLength
                or      cl,cl
                jz      @f
                mov     di, offset InputFileName
                mov     si, offset StringBuffer
        rep     movsb
                stosb
        @@:
                mov     dx,offset PromptO
                call   _puts
                mov     dx, offset InputBuffer
                mov     ah,0Ah
                int 21h
                mov     dx,offset CRLF
                call    _puts
                mov     al,0
                mov     ch,0
                mov     cl,StringLength
                or      cl,cl
                jz      NoFilename
                mov     di, offset OutputFileName
                mov     si, offset StringBuffer
        rep     movsb
                stosb
                clc
                ret
NoFilename:     stc
                ret
Prompt          DB      "PC-9801-92{[h̑SROMf[^128KB̃t@CƂȂ܂. ",13,10
                DB      "͂яo̓t@Cw肷Kv܂. ",13,10,0
PromptI         DB      "̓t@C ==>",0
PromptO         DB      "o̓t@C ==>",0
InputBuffer     DB 120
StringLength    DB 0
StringBuffer    DB 120 dup(0)
InputFileName   DB "92BIOS1M.BIN", 110 dup(0)
OutputFileName  DB "92BIOS1M.ROM", 110 dup(0)
GetFilenames    ENDP
;------------------------------------------------
StackBase       label   byte

code    ends
        end     start
